declare class ProviderClass<Provide, Input = unknown> {
    provider: (scope: Scope, input: Input) => Provide | Promise<Provide>;
    constructor(provider: (scope: Scope, input: Input) => Provide | Promise<Provide>);
}
type Provider<Provide, Input = unknown> = (input: Input) => Provide | Promise<Provide>;
type OnResolve = {
    filter: (target: unknown) => boolean;
    cb: <T>(target: T) => T;
};
type Defer = (e?: unknown) => void | Promise<void>;
declare class Scope {
    private store;
    private resolves;
    private defers;
    constructor(store?: Map<Executor<any>, Promise<any>>, resolves?: OnResolve[], defers?: Defer[]);
    has(executor: Executor<any>): boolean;
    get<T>(executor: Executor<T>): Promise<T>;
    set<T>(executor: Executor<T>, v: T | Promise<T> | Executor<T>): void;
    resolveValue<T>(executor: Executor<T>, value: T | Executor<T>): void;
    resolve<T>(executor: EODE<T>): Promise<T>;
    execute<Dependent, Output>(executable: Provider<Output, Dependent>, dependency: EODE<Dependent>): Promise<Awaited<Output>>;
    prepare<Dependent, Input extends Array<any>, Output>(provider: (provide: Dependent, ...input: Input) => Output, dependency: EODE<Dependent>): (...input: Input) => Promise<Awaited<ReturnType<typeof provider>>>;
    addDefer(deferer: Defer): void;
    addOnResolves(onResolve: OnResolve): void;
    get onResolves(): OnResolve[];
    dispose(): Promise<void>;
}
declare function createScope(): Scope;
declare function getScope(): Scope;
declare function dispose(): void;
type Executor<Value> = {
    resolve(scope: Scope): Promise<Value>;
    reset(): void;
    patch<T>(executor: Executor<T>, patch: Executor<T> | T): void;
    readonly [x: symbol]: true;
};
declare function isExecutor<P, D>(obj: any): obj is Executor<P>;
declare class Execution<Input extends Array<any>, Output, Dependency> {
    private executor;
    private dependency;
    constructor(executor: (dependency: Dependency, ...input: Input) => Output | Promise<Output>, dependency: EODE<Dependency>);
    executeIn(scope: Scope, ...input: Input): Promise<Awaited<Output>>;
    execute(...input: Input): Promise<Awaited<Output>>;
    resolve(scope?: Scope): (...input: Input) => Promise<Awaited<Output>>;
}
declare function createExecution<Dependency, Input extends Array<any>, Output>(executor: (dependency: Dependency, ...input: Input) => Output | Promise<Output>, dependency: Executor<Dependency>): Execution<Input, Output, Dependency>;
type EODE<D> = Executor<D> | {
    [key in keyof D]: Executor<D[key]>;
};
declare function create<P>(providerClass: ProviderClass<P>): Executor<P>;
declare function create<P, D>(providerClass: ProviderClass<P, D>, dependencies: EODE<D>): Executor<P>;
declare function create<P>(provider: Provider<P>): Executor<P>;
declare function create<P, D>(provider: Provider<P, D>, dependencies: EODE<D>): Executor<P>;
declare const value: <Provide>(value: Provide) => Executor<Provide>;
declare const group: <Provide>(...values: Executor<Provide>[]) => Executor<Awaited<Provide>[]>;
declare const scoper: Executor<Scope>;
declare function prepare<Dependent, Input extends Array<any>, Output>(provider: ((provide: Dependent, ...input: Input) => Output), dependency: EODE<Dependent>, scope?: Scope): (...input: Input) => Promise<Awaited<Output>>;
declare function execute<Dependent, Output>(executable: Provider<Output, Dependent>, dependency: EODE<Dependent>, scope?: Scope): Promise<Awaited<Output>>;
declare function resolve<T>(executor: Executor<T>, scope?: Scope): Promise<T>;
declare function resolveValue<T>(executor: Executor<T>, value: T | Executor<T>, scope?: Scope): void;
type inferProvide<T> = T extends Executor<infer S> ? S : never;
declare function combine<L extends Record<string, Executor<any>>>(layout: L): Executor<{
    [key in keyof L]: inferProvide<L[key]>;
}>;

export { Execution, type Executor, ProviderClass, Scope, combine, create, createExecution, createScope, dispose, execute, getScope, group, type inferProvide, isExecutor, prepare, resolve, resolveValue, scoper, value };
